--[[
###################################
Ultra XP,Rep,Azerite Bars: keivamp#
###################################
]]--

	local UltraXPRA_Bars = LibStub("AceAddon-3.0"):GetAddon("UltraXPRA_Bars")

	AutoRep = {};
	AutoRep.lastupdate = 0;
	AutoRep.lastamount = 0;
	local MyRepWidth = 350
	local MyRepHeight = 15
	local RepPX =  230
	local RepPY = -10
	local Repframe = CreateFrame("Frame", nil, UIParent)
	--local MyRepSettingsFrame = CreateFrame("Frame")

	local function CreateBackdrop(frame)
		frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
		insets = {top = 0, left = 0, bottom = 0, right = 0}})
		frame:SetBackdropColor(0,0,0,0.75)
		frame:SetBackdropBorderColor(0,0,0,1)
	end
	
	Repframe:EnableMouse(true)
	
	Repframe.bar = CreateFrame("StatusBar", nil, Repframe)
	Repframe.bar:SetPoint("TOPLEFT",0, 0)
	Repframe.bar:SetPoint("TOPRIGHT", 0, 0)
	Repframe.bar:SetStatusBarTexture("Interface\\TargetingFrame\\UI-StatusBar")

	--Repframe.bar:SetOrientation("VERTICAL")
	--Repframe.bar:SetOrientation("HORIZONTAL")
	Repframe.bar:GetStatusBarTexture():SetHorizTile(false)
	Repframe.bar:GetStatusBarTexture():SetVertTile(false)
	Repframe.bar:SetStatusBarColor(0,.85,0)

	local REPText = Repframe.bar:CreateFontString(nil, "OVERLAY", "SystemFont_Med1")
			REPText:SetPoint("CENTER", 0, 0)
			REPText:SetJustifyH("CENTER")

	local REPMaxText = Repframe.bar:CreateFontString(nil, "OVERLAY", "SystemFont_Med1")
			REPMaxText:SetPoint("RIGHT", -2, 0)
			--REPMaxText:SetJustifyH("RIGHT")

	local RepCurrentText = Repframe.bar:CreateFontString(nil, "OVERLAY", "SystemFont_Med1")
			RepCurrentText:SetPoint("LEFT", 2, 0)
			--RepCurrentText:SetJustifyH("LEFT")


local function UpdateRep()
	if UltraXPRA_Bars.db.char.UseUltraRep == false then return end	
	--Fonts--
	local TheFont = ""
	if UltraXPRA_Bars.db.char.RepFontKey == "2002" then
	TheFont = "Fonts\\2002.ttf"
	elseif UltraXPRA_Bars.db.char.RepFontKey == "2002 Bold" then
	TheFont = "Fonts\\2002B.ttf"
	elseif UltraXPRA_Bars.db.char.RepFontKey == "AR CrystalzcuheiGBK Demibold" then
	TheFont = "Fonts\\ARHei.ttf"
	elseif UltraXPRA_Bars.db.char.RepFontKey == "AR ZhongkaiGBK Medium (Combat)" then
	TheFont = "Fonts\\ARKai_C.ttf"
	elseif UltraXPRA_Bars.db.char.RepFontKey == "AR ZhongkaiGBK Medium" then
	TheFont = "Fonts\\ARKai_T.ttf"
	elseif UltraXPRA_Bars.db.char.RepFontKey == "Arial Narrow" then
	TheFont = "Fonts\\ARIALN.ttf"
	elseif UltraXPRA_Bars.db.char.RepFontKey == "Friz Quadrata TT" then
	TheFont = "Fonts\\FRIZQT__.ttf"
	elseif UltraXPRA_Bars.db.char.RepFontKey == "MoK" then
	TheFont = "Fonts\\K_Pagetext.ttf"
	elseif UltraXPRA_Bars.db.char.RepFontKey == "Morpheus" then
	TheFont = "Fonts\\MORPHEUS_CYR.ttf"
	elseif UltraXPRA_Bars.db.char.RepFontKey == "Nimrod MT" then
	TheFont = "Fonts\\NIM_____.ttf"
	elseif UltraXPRA_Bars.db.char.RepFontKey == "Skurri" then
	TheFont = "Fonts\\SKURRI_CYR.ttf"
	else
	TheFont = "Interface\\Addons\\UltraXPRA_Bars\\Fonts\\"..UltraXPRA_Bars.db.char.RepFontKey..".ttf"
	end
	local TheFontOutline = "NONE"
	if UltraXPRA_Bars.db.char.RepFontOutline == 1 then
	TheFontOutline = "NONE"
	elseif UltraXPRA_Bars.db.char.RepFontOutline == 2 then
	TheFontOutline = "MONOCHROMEOUTLINE"
	elseif UltraXPRA_Bars.db.char.RepFontOutline == 3 then
	TheFontOutline = "THINOUTLINE"
	elseif UltraXPRA_Bars.db.char.RepFontOutline == 4 then
	TheFontOutline = "THICKOUTLINE"
	end
		if UltraXPRA_Bars.db.char.RepFontKey == "Folkard" then
			REPText:SetPoint("CENTER", 0, -3)
			REPMaxText:SetPoint("RIGHT", -2, -3)
			RepCurrentText:SetPoint("LEFT", 2, -3)
		elseif UltraXPRA_Bars.db.char.RepFontKey == "Atari" then
			REPText:SetPoint("CENTER", 0, 2)
			REPMaxText:SetPoint("RIGHT", -2, 2)
			RepCurrentText:SetPoint("LEFT", 2, 2)
		else
			REPText:SetPoint("CENTER", 0, 0)
			REPMaxText:SetPoint("RIGHT", -2, 0)
			RepCurrentText:SetPoint("LEFT", 2, 0)
		end
	--end fonts --
	local MyRepWidth = UltraXPRA_Bars.db.char.RepWidth
	local MyRepHeight = UltraXPRA_Bars.db.char.RepHeight
	local RepPX = UltraXPRA_Bars.db.char.RepMoveX
	local RepPY = UltraXPRA_Bars.db.char.RepMoveY
	
	Repframe.bar:SetHeight(MyRepHeight)
	
	Repframe:SetClampedToScreen(true)
	Repframe:SetClampRectInsets(0, 0, 0,0)

	Repframe:SetHeight(MyRepHeight)
	Repframe:SetWidth(MyRepWidth)

	Repframe:ClearAllPoints()
	Repframe:SetPoint("TOP", UIParent, "TOP", RepPX,RepPY)	
		
	Repframe:CreateBeautyBorder(4)
	Repframe:SetBeautyBorderPadding(0)
	Repframe:SetBeautyBorderTexture("white")
	
	CreateBackdrop(Repframe)
	if UltraXPRA_Bars.db.char.UseVertRep == true then
		Repframe.bar:SetOrientation("VERTICAL")
		UltraXPRA_Bars.db.char.ShowFactionName = false
		UltraXPRA_Bars.db.char.ShowMaxRep = false
		UltraXPRA_Bars.db.char.ShowMinRep = false	
	else
		Repframe.bar:SetOrientation("HORIZONTAL")
	end
	
	if UltraXPRA_Bars.db.char.RepCustomFont == false then 
	REPText:SetFont("SystemFont_Med1", MyRepHeight-4, "OUTLINE")
	REPText:SetTextColor(1, 1, 1, 1);
	REPMaxText:SetFont("SystemFont_Med1", MyRepHeight-4, "OUTLINE")
	REPMaxText:SetTextColor(1, 1, 1, 1);
	RepCurrentText:SetFont("SystemFont_Med1", MyRepHeight-4, "OUTLINE")	
	RepCurrentText:SetTextColor(1, 1, 1, 1);
	else
	REPText:SetFont(TheFont, UltraXPRA_Bars.db.char.RepFontSize, TheFontOutline)
	REPMaxText:SetFont(TheFont, UltraXPRA_Bars.db.char.RepFontSize, TheFontOutline)
	RepCurrentText:SetFont(TheFont, UltraXPRA_Bars.db.char.RepFontSize, TheFontOutline)	
	end	
	--REPText:SetWidth(MyRepWidth/2)

	local name, standing, min, max, value, factionID = GetWatchedFactionInfo()
	--value = 3000
	if standing == 1 then
	Repframe.bar:SetStatusBarColor(1,0.1,0.1)
	Repframe:SetBeautyBorderColor(1,0.1,0.1,0.75)
	end
	if standing == 2 then
	Repframe.bar:SetStatusBarColor(1,0.5,0.25)
	Repframe:SetBeautyBorderColor(1,0.5,0.25,0.75)
	end
	if standing == 3 then
	Repframe.bar:SetStatusBarColor(1,0.7,0.3)
	Repframe:SetBeautyBorderColor(1,0.7,0.3,0.75)
	end
	if standing == 4 then
	Repframe.bar:SetStatusBarColor(1,1,0)
	Repframe:SetBeautyBorderColor(1,1,0,0.75)
	end
	if standing == 5 then
	Repframe.bar:SetStatusBarColor(0.32,0.67,0)
	Repframe:SetBeautyBorderColor(0.32,0.67,0,0.75)
	end
	if standing == 6 then
	Repframe.bar:SetStatusBarColor(0,0.44,1)
	Repframe:SetBeautyBorderColor(0,0.44,1,0.75)
	end
	if standing == 7 then
	Repframe.bar:SetStatusBarColor(0.64,0.21,0.93)
	Repframe:SetBeautyBorderColor(0.64,0.21,0.93,0.75)
	end
	if standing == 8 then
	Repframe.bar:SetStatusBarColor(0.9,0.8,0.5)
	Repframe:SetBeautyBorderColor(0.9,0.8,0.5,0.75)
	end
	
	--[[
	[1] = {r = 1, g = 0.1, b = 0.1},
    [2] = {r = 1, g = 0.5, b = 0.25},
    [3] = {r = 1, g = 0.7, b = 0.3},
    [4] = {r = 1, g = 1, b = 0},
    [5] = {r = 0.32, g = 0.67, b = 0},
    [6] = {r = 0, g = 0.43922, b = 1},
    [7] = {r = 0.63922, g = 0.20784, b = 0.93333},
    [8] = {r = 0.90196, g = 0.8, b = 0.50196},
	
	Repframe.bar:SetStatusBarColor(0,.85,0)
	]]--
		if factionID and C_Reputation.IsFactionParagon(factionID) then
			 local currentValue, threshold, rewardQuestID, hasRewardPending, tooLowLevelForParagon = C_Reputation.GetFactionParagonInfo(factionID)
			-- local something = C_Reputation.RequestFactionParagonPreloadRewardData(factionID)
				local ParaMax = threshold
				local ParaCurrent = currentValue
				local doodley = 0
				for i = 1,9999 do 
				
					if ParaCurrent > (ParaMax * doodley) then
						doodley = doodley + 1
					end
				end
					ParaCurrent = currentValue - (ParaMax * doodley) + threshold
					
				Repframe.bar:SetMinMaxValues(1, threshold)
				Repframe.bar:SetValue(ParaCurrent)

					if UltraXPRA_Bars.db.char.ShowFactionName == true then 
					REPText:SetText(name)
					else
					REPText:SetText("")
					end
					if UltraXPRA_Bars.db.char.ShowMinRep == true then 
					RepCurrentText:SetText(ParaCurrent)
					else
					RepCurrentText:SetText("")
					end	
					if UltraXPRA_Bars.db.char.ShowMaxRep == true then 
					REPMaxText:SetText(threshold)
					else
					REPMaxText:SetText("")
					end	
				else 
			--	currentRep = value-min
				MaxRep = max-min
				MinRep = min - min
		
				Repframe.bar:SetMinMaxValues(MinRep, MaxRep)
				Repframe.bar:SetValue(currentRep)

					if UltraXPRA_Bars.db.char.ShowMinRep == true then 
					RepCurrentText:SetText(currentRep)
					else
					RepCurrentText:SetText("")
					end	
					if UltraXPRA_Bars.db.char.ShowMaxRep == true then 
					REPMaxText:SetText(MaxRep)
					else
					REPMaxText:SetText("")
					end	
					if UltraXPRA_Bars.db.char.ShowFactionName == true then 
					REPText:SetText(name)
					else
					REPText:SetText("")
					end	

			end

end	

local function OnEvent(self)
			
		local name, standing, min, max, value, factionID = GetWatchedFactionInfo()
		currentRep = value-min
		MaxRep = max-min
		MinRep = min - min
				
		-- Setup
				if name == nil then
					Repframe:Hide()	
				elseif currentRep > 0 then
					Repframe:Show()
				end
				
		self:SetScript("OnEnter", function()
			
			GameTooltip:SetOwner(self, "ANCHOR_BOTTOM", 0, -10)
			GameTooltip:ClearAllPoints()
			GameTooltip:SetPoint("BOTTOM", self, "TOP", 0, 1)
			GameTooltip:ClearLines()
			GameTooltip:AddDoubleLine(name)
			GameTooltip:AddLine(" ")
			local myStanding = "" 
			if standing == 1 then
				myStanding = "Hated"
			end
			if standing == 2 then
				myStanding = "Hostile"
			end
			if standing == 3 then
				myStanding = "Unfriendly"
			end
			if standing == 4 then
				myStanding = "Nuetral"
			end
			if standing == 5 then
				myStanding = "Friendly"
			end
			if standing == 6 then
				myStanding = "Honored"
			end
			if standing == 7 then
				myStanding = "Revered"
			end
			if standing == 8 then
				myStanding = "Exalted"
			end
		
			if factionID and C_Reputation.IsFactionParagon(factionID) then
				if standing == 8 then
					Repframe.bar:SetStatusBarColor(0.95,0.85,0.55)
					Repframe:SetBeautyBorderColor(0.95,0.85,0.55,0.75)
				end
			 local currentValue, threshold, rewardQuestID, hasRewardPending, tooLowLevelForParagon = C_Reputation.GetFactionParagonInfo(factionID)


				local ParaMax = threshold
				local ParaCurrent = currentValue
				local doodley = 0
				for i = 1,150 do 
				
					if ParaCurrent > (ParaMax * doodley) then
						doodley = doodley + 1
					end
				end
					ParaCurrent = currentValue - (ParaMax * doodley) + threshold
					--next i

				GameTooltip:AddDoubleLine("Paragon")
				GameTooltip:AddLine(" ")
				GameTooltip:AddDoubleLine(ParaCurrent .. " / " .. ParaMax)
				else 
				GameTooltip:AddDoubleLine(myStanding)
				GameTooltip:AddLine(" ")
				GameTooltip:AddDoubleLine(currentRep .." / " .. MaxRep)
			end

			GameTooltip:Show()
		end)
		self:SetScript("OnLeave", function() GameTooltip:Hide() end)
		
	end
	
		Repframe:SetScript("OnMouseDown", function(self, button)
		if button == "RightButton" then
			
			self:GetScript("OnEnter")(self)
		else
			ToggleCharacter("ReputationFrame")
		end
	end)

Repframe:SetScript("OnEvent", OnEvent)
Repframe:HookScript("OnUpdate", UpdateRep)
Repframe:RegisterEvent("UPDATE_FACTION")

function AutoRep.OnEvent(_, event, arg1)
	if(event == "COMBAT_TEXT_UPDATE" and arg1 == "FACTION") then
			local faction, amount = GetCurrentCombatTextEventInfo()

			if (faction ~= "Guild") then
				if (amount > AutoRep.lastamount) or (time() > AutoRep.lastupdate) then
					for i=1,GetNumFactions() do
						if faction == GetFactionInfo(i) then
						
							SetWatchedFactionIndex(i);
						end
					end
				end
				AutoRep.lastamount = amount;
				AutoRep.lastupdate = time();
			end
		
	end
end

AutoRep.frame = CreateFrame("Frame", nil, UIParent);
AutoRep.frame:RegisterEvent("COMBAT_TEXT_UPDATE");
AutoRep.frame:SetScript("OnEvent", AutoRep.OnEvent);