--[[
###################################
Ultra XP,Rep,Azerite Bars: keivamp#
###################################
]]--

local UltraXPRA_Bars = LibStub("AceAddon-3.0"):GetAddon("UltraXPRA_Bars")
--local L = LibStub("AceLocale-3.0")
local LSM = LibStub("LibSharedMedia-3.0")
function UltraXPRA_Bars:GetOptions()
    local db = self.db.char
    local options = {
        name = "UltraXPRA_Bars",
        handler = UltraXPRA_Bars,
        type = "group",
       -- childGroups = "tab",
        args = {
            -- enableDisable = {
               -- order = 10,
               -- name = ENABLE .. " " .. JUST_OR .. " " .. DISABLE,
               -- desc = "Toggle Addon on or off.",
               -- descStyle = "inline",
               -- type = "toggle",
               -- width = "full",
               -- get = function() return db.enabled end,
               -- set = function(info, value)
                   -- db.enabled = value
                   -- if value then
                       -- self:OnEnable()
                   -- else
                       -- self:OnDisable()
                   -- end
               -- end
            -- },
			XPBar = {
                order = 1,
                name = "Xp Bar",
                type = "group",
                args = {
					-- font = {
							 -- type = 'select',
							 -- dialogControl = 'LSM30_Font', --Select your widget here
							 -- name = 'Some Name',
							 -- desc = 'Some Description',
							 -- values = LSM:HashTable("font"), -- pull in your font list from LSM
							 -- get = function()
								  -- return current -- variable that is my current selection
							 -- end,
							 -- set = function(self,key)
								  -- current = key -- saves our new selection the the current one
							 -- end,
						-- }
                   
                    UseUltraXP = {
                        order = 2,
                        name = "Use Ultra XP",
                        desc = "The really cool XP bar",
                        descStyle = "inline",
                        type = "toggle",
                        width = "single",
                        get = function() return db.UseUltraXP end,
                        set = function(info, value) db.UseUltraXP = value end
                    },
					XPCustomFont = {
                        order = 3,
                        name = "Font",
                        desc = "Use the Custom Font",
                        descStyle = "inline",
                        type = "toggle",
                        width = "single",
                        get = function() return db.XPCustomFont end,
                        set = function(info, value) db.XPCustomFont = value end
                    },
					XPMoveY = {
                        order = 4,
                        name = "Move Up and Down",
                        desc = "Move the XP Bar up and down",
                        descStyle = "inline",
                        type = "range",
                        width = "double",
						min = -1500,
						max = 1500,
						softMin = -1500,
						softMax  = 1500,
						step  = 1,
						bigStep = 5,
						isPercent = false,
                        get = function() return db.XPMoveY end,
                        set = function(info, value) db.XPMoveY = value end
                    },
					XPMoveX = {
                        order = 5,
                        name = "Left And Right",
                        desc = "Move the XP Bar left and right",
                        descStyle = "inline",
                        type = "range",
                        width = "double",
						min = -1500,
						max = 1500,
						softMin = -1500,
						softMax  = 1500,
						step  = 1,
						bigStep = 5,
						isPercent = false,
                        get = function() return db.XPMoveX end,
                        set = function(info, value) db.XPMoveX = value end
                    },
					XPWidth = {
                        order = 6,
                        name = "Width",
                        desc = "How wide do you want it?",
                        descStyle = "inline",
                        type = "range",
                        width = "double",
						min = 5,
						max = 2500,
						softMin = 5,
						softMax  = 2500,
						step  = 1,
						bigStep = 5,
						isPercent = false,
                        get = function() return db.XPWidth end,
                        set = function(info, value) db.XPWidth = value end
                    },
					XPHeight = {
                        order = 7,
                        name = "Height",
                        desc = "How tall do you want this bar?",
                        descStyle = "inline",
                        type = "range",
                        width = "double",
						min = 5,
						max = 2500,
						softMin = 5,
						softMax  = 2500,
						step  = 1,
						bigStep = 5,
						isPercent = false,
                        get = function() return db.XPHeight end,
                        set = function(info, value) db.XPHeight = value end
                    },
					 ShowRested = {
                        order = 8,
                        name = "Show Rested XP",
                        desc = "Displays the rested XP amount if any",
                        descStyle = "inline",
                        type = "toggle",
                        width = "double",
                        get = function() return db.ShowRested end,
                        set = function(info, value) db.ShowRested = value end
                    },
					ShowMaxXP = {
                        order = 9,
                        name = "Show Needed XP",
                        desc = "Displays how much total XP is need to get to the next level on the right",
                        descStyle = "inline",
                        type = "toggle",
                        width = "double",
                        get = function() return db.ShowMaxXP end,
                        set = function(info, value) db.ShowMaxXP = value end
                    },
					ShowMinXP = {
                        order = 10,
                        name = "Show Current",
                        desc = "Displays your current xp on the left",
                        descStyle = "inline",
                        type = "toggle",
                        width = "double",
                        get = function() return db.ShowMinXP end,
                        set = function(info, value) db.ShowMinXP = value end
                    },
					font = {
				    order = 11,
						type = 'select',
						 dialogControl = 'LSM30_Font', 
						 name = 'Font Name',
						 desc = 'Fonts for peeps who like to change fonts',
						 values = LSM:HashTable("font"),				
						  get = function()
							  return db.XPFontKey -- variable that is my current selection
						 end,
						 set = function(self,key)
							  db.XPFontKey = key -- saves our new selection the the current one
						 end,
					},
					XPFontOutline = {
					order = 12,
						type = 'select',
						name = 'Font Outline',
						desc = 'Outlines for the fonts',
						 values = {"None","MonoChrome","Thin","Thick"},
						  get = function()
							  return db.XPFontOutline -- variable that is my current selection
						 end,
						 set = function(self,key)
							
							  db.XPFontOutline = key -- saves our new selection the the current one
							-- print(key)
						 end,
					},
					XPFontSize = {
                        order = 13,
                        name = "Font Size",
                        desc = "Size of the font",
                        descStyle = "inline",
                        type = "range",
                        width = "double",
						min = 6,
						max = 100,
						softMin = 6,
						softMax  = 100,
						step  = 1,
						bigStep = 1,
						isPercent = false,
                        get = function() return db.XPFontSize end,
                        set = function(info, value) db.XPFontSize = value end
                    },
					VERTICAL = {
                        order = 19,
                        name = "VERTICAL XP",
                        desc = "VERTICAL",
                        descStyle = "inline",
                        type = "toggle",
                        width = "double",
                        get = function() return db.UseVertXP end,
                        set = function(info, value) db.UseVertXP = value end
                    }
             
                }
            },
			RepBar = {
                order = 20,
                name = "Rep Bar",
                type = "group",
                args = {
                   
                    UseUltraRep = {
                        order = 21,
                        name = "Use Ultra Rep",
                        desc = "The really cool Rep bar",
                        descStyle = "inline",
                        type = "toggle",
                        width = "single",
                        get = function() return db.UseUltraRep end,
                        set = function(info, value) db.UseUltraRep = value end
                    },
					RepCustomFont = {
                        order = 22,
                        name = "Font",
                        desc = "Use the Custom Font",
                        descStyle = "inline",
                        type = "toggle",
                        width = "single",
                        get = function() return db.RepCustomFont end,
                        set = function(info, value) db.RepCustomFont = value end
                    },
					RepMoveY = {
                        order = 23,
                        name = "Move Up and Down",
                        desc = "Move the Rep Bar up and down",
                        descStyle = "inline",
                        type = "range",
                        width = "double",
						min = -1500,
						max = 1500,
						softMin = -1500,
						softMax  = 1500,
						step  = 1,
						bigStep = 5,
						isPercent = false,
                        get = function() return db.RepMoveY end,
                        set = function(info, value) db.RepMoveY = value end
                    },
					RepMoveX = {
                        order = 24,
                        name = "Left And Right",
                        desc = "Move the Rep Bar left and right",
                        descStyle = "inline",
                        type = "range",
                        width = "double",
						min = -1500,
						max = 1500,
						softMin = -1500,
						softMax  = 1500,
						step  = 1,
						bigStep = 5,
						isPercent = false,
                        get = function() return db.RepMoveX end,
                        set = function(info, value) db.RepMoveX = value end
                    },
					RepWidth = {
                        order = 25,
                        name = "Width",
                        desc = "How wide do you want it?",
                        descStyle = "inline",
                        type = "range",
                        width = "double",
						min = 5,
						max = 2500,
						softMin = 5,
						softMax  = 2500,
						step  = 1,
						bigStep = 5,
						isPercent = false,
                        get = function() return db.RepWidth end,
                        set = function(info, value) db.RepWidth = value end
                    },
					RepHeight = {
                        order = 26,
                        name = "Height",
                        desc = "How tall do you want this bar?",
                        descStyle = "inline",
                        type = "range",
                        width = "double",
						min =5,
						max = 2500,
						softMin = 5,
						softMax  = 2500,
						step  = 1,
						bigStep = 5,
						isPercent = false,
                        get = function() return db.RepHeight end,
                        set = function(info, value) db.RepHeight = value end
                    },
					 ShowFactionName = {
                        order = 27,
                        name = "Show Rep Faction",
                        desc = "Displays the Rep Faction",
                        descStyle = "inline",
                        type = "toggle",
                        width = "double",
                        get = function() return db.ShowFactionName end,
                        set = function(info, value) db.ShowFactionName = value end
                    },
					ShowMaxRep = {
                        order = 28,
                        name = "Show Needed Rep",
                        desc = "Displays how much total Rep is need to get to the next level on the right",
                        descStyle = "inline",
                        type = "toggle",
                        width = "double",
                        get = function() return db.ShowMaxRep end,
                        set = function(info, value) db.ShowMaxRep = value end
                    },
					ShowMinRep = {
                        order = 29,
                        name = "Show Current Rep",
                        desc = "Displays your current Rep on the left",
                        descStyle = "inline",
                        type = "toggle",
                        width = "double",
                        get = function() return db.ShowMinRep end,
                        set = function(info, value) db.ShowMinRep = value end
                    },
					font = {
				    order = 30,
						type = 'select',
						 dialogControl = 'LSM30_Font', 
						 name = 'Font Name',
						 desc = 'Fonts for peeps who like to change fonts',
						 values = LSM:HashTable("font"),				
						  get = function()
							  return db.RepFontKey -- variable that is my current selection
						 end,
						 set = function(self,key)
							  db.RepFontKey = key -- saves our new selection the the current one
						 end,
					},
					RepFontOutline = {
					order = 31,
						type = 'select',
						name = 'Font Outline',
						desc = 'Outlines for the fonts',
						 values = {"None","MonoChrome","Thin","Thick"},
						  get = function()
							  return db.RepFontOutline -- variable that is my current selection
						 end,
						 set = function(self,key)
							
							  db.RepFontOutline = key -- saves our new selection the the current one
							-- print(key)
						 end,
					},
					RepFontSize = {
                        order = 32,
                        name = "Font Size",
                        desc = "Size of the font",
                        descStyle = "inline",
                        type = "range",
                        width = "double",
						min = 6,
						max = 100,
						softMin = 6,
						softMax  = 100,
						step  = 1,
						bigStep = 1,
						isPercent = false,
                        get = function() return db.RepFontSize end,
                        set = function(info, value) db.RepFontSize = value end
                    },
					RepVERTICAL = {
                        order = 39,
                        name = "VERTICAL Rep",
                        desc = "VERTICAL Rep",
                        descStyle = "inline",
                        type = "toggle",
                        width = "double",
                        get = function() return db.UseVertRep end,
                        set = function(info, value) db.UseVertRep = value end
                    }
             
                }
            },			
			AzeBar = {
                order = 40,
                name = "Azerite Bar",
                type = "group",
                args = {
                   
                    UseUltraAze = {
                        order = 41,
                        name = "Use Ultra Azerite",
                        desc = "The really cool Azerite bar",
                        descStyle = "inline",
                        type = "toggle",
                        width = "single",
                        get = function() return db.UseUltraAze end,
                        set = function(info, value) db.UseUltraAze = value end
                    },
					AzeCustomFont = {
                        order = 42,
                        name = "Font",
                        desc = "Use the Custom Font",
                        descStyle = "inline",
                        type = "toggle",
                        width = "single",
                        get = function() return db.AzeCustomFont end,
                        set = function(info, value) db.AzeCustomFont = value end
                    },
					AzeMoveY = {
                        order = 43,
                        name = "UP&DOWN!",
                        desc = "UP and DOWN!!!!",
                        descStyle = "inline",
                        type = "range",
                        width = "double",
						min = -1500,
						max = 1500,
						softMin = -1500,
						softMax  = 1500,
						step  = 1,
						bigStep = 5,
						isPercent = false,
                        get = function() return db.AzeMoveY end,
                        set = function(info, value) db.AzeMoveY = value end
                    },
					AzeMoveX = {
                        order = 44,
                        name = "LEFT&RIGHT!",
                        desc = " Bar LEFT and RIGHT!!!!",
                        descStyle = "inline",
                        type = "range",
                        width = "double",
						min = -1500,
						max = 1500,
						softMin = -1500,
						softMax  = 1500,
						step  = 1,
						bigStep = 5,
						isPercent = false,
                        get = function() return db.AzeMoveX end,
                        set = function(info, value) db.AzeMoveX = value end
                    },
					AzeWidth = {
                        order = 45,
                        name = "Width",
                        desc = "Bar Width!!!!",
                        descStyle = "inline",
                        type = "range",
                        width = "double",
						min = 5,
						max = 2500,
						softMin = 5,
						softMax  = 2500,
						step  = 1,
						bigStep = 5,
						isPercent = false,
                        get = function() return db.AzeWidth end,
                        set = function(info, value) db.AzeWidth = value end
                    },
					AzeHeight = {
                        order = 46,
                        name = "Height",
                        desc = "Bar Height!!!!",
                        descStyle = "inline",
                        type = "range",
                        width = "double",
						min = 5,
						max = 2500,
						softMin = 5,
						softMax  = 2500,
						step  = 1,
						bigStep = 5,
						isPercent = false,
                        get = function() return db.AzeHeight end,
                        set = function(info, value) db.AzeHeight = value end
                    },
					 AzeritePower = {
                        order = 47,
                        name = "Show Azerite Level",
                        desc = "Displays the Azerite Level",
                        descStyle = "inline",
                        type = "toggle",
                        width = "double",
                        get = function() return db.AzeritePower end,
                        set = function(info, value) db.AzeritePower = value end
                    },
					ShowMaxAze = {
                        order = 48,
                        name = "Show Needed Azerite",
                        desc = "Displays how much total Azerite is need to get to the next level on the right",
                        descStyle = "inline",
                        type = "toggle",
                        width = "double",
                        get = function() return db.ShowMaxAze end,
                        set = function(info, value) db.ShowMaxAze = value end
                    },
					ShowMinAze = {
                        order = 49,
                        name = "Show Current Azerite",
                        desc = "Displays your current Azerite on the left",
                        descStyle = "inline",
                        type = "toggle",
                        width = "double",
                        get = function() return db.ShowMinAze end,
                        set = function(info, value) db.ShowMinAze = value end
                    },
					font = {
				    order = 50,
						type = 'select',
						 dialogControl = 'LSM30_Font', 
						 name = 'Font Name',
						 desc = 'Fonts for peeps who like to change fonts',
						 values = LSM:HashTable("font"),				
						  get = function()
							  return db.AzeFontKey -- variable that is my current selection
						 end,
						 set = function(self,key)
							  db.AzeFontKey = key -- saves our new selection the the current one
						 end,
					},
					AzeFontOutline = {
					order = 51,
						type = 'select',
						name = 'Font Outline',
						desc = 'Outlines for the fonts',
						 values = {"None","MonoChrome","Thin","Thick"},
						  get = function()
							  return db.AzeFontOutline -- variable that is my current selection
						 end,
						 set = function(self,key)
							
							  db.AzeFontOutline = key -- saves our new selection the the current one
							-- print(key)
						 end,
					},
					AzeFontSize = {
                        order = 52,
                        name = "Font Size",
                        desc = "Size of the font",
                        descStyle = "inline",
                        type = "range",
                        width = "double",
						min = 6,
						max = 100,
						softMin = 6,
						softMax  = 100,
						step  = 1,
						bigStep = 1,
						isPercent = false,
                        get = function() return db.AzeFontSize end,
                        set = function(info, value) db.AzeFontSize = value end
                    },
					AzeVERTICAL = {
                        order = 59,
                        name = "VERTICAL Rep",
                        desc = "VERTICAL Azerite",
                        descStyle = "inline",
                        type = "toggle",
                        width = "double",
                        get = function() return db.UseVertAze end,
                        set = function(info, value) db.UseVertAze = value end
                    }
             
                }
            },
			-- Font = {
               -- order = 31,
               -- name = "Fonts",
               -- type = "group",
               -- args = {
                   -- font = {
				    -- order = 32,
						-- type = 'select',
						 -- dialogControl = 'LSM30_Font', 
						 -- name = 'Font Name',
						 -- desc = 'Fonts for peeps who like to change fonts',
						 -- values = LSM:HashTable("font"),				
						  -- get = function()
							  -- return db.FontKey -- variable that is my current selection
						 -- end,
						 -- set = function(self,key)
							  -- db.FontKey = key -- saves our new selection the the current one
						 -- end,
					-- },
					-- FontOutline = {
					-- order = 33,
						-- type = 'select',
						-- name = 'Font Outline',
						-- desc = 'Outlines for the fonts',
						 -- values = {"None","MonoChrome","Thin","Thick"},
						  -- get = function()
							  -- return db.FontOutline -- variable that is my current selection
						 -- end,
						 -- set = function(self,key)
							
							  -- db.FontOutline = key -- saves our new selection the the current one
							--print(key)
						 -- end,
					-- },
					-- FontSize = {
                        -- order = 34,
                        -- name = "Font Size",
                        -- desc = "Size of the font",
                        -- descStyle = "inline",
                        -- type = "range",
                        -- width = "double",
						-- min = 10,
						-- max = 50,
						-- softMin = 10,
						-- softMax  = 50,
						-- step  = 1,
						-- bigStep = 1,
						-- isPercent = false,
                        -- get = function() return db.FontSize end,
                        -- set = function(info, value) db.FontSize = value end
                    -- }
               -- }
           -- },
			Reset = {
                order = 41,
                name = "Reset",
                type = "group",
                args = {
                   
                    ResetBox = {
                        order = 42,
                        name = "Reset to defaults",
                        desc = "Resets the settings to teh default configuration.",
                        descStyle = "inline",
                        type = "toggle",
                        width = "double",
                        get = function() return db.ResetBox end,
                        set = function(info, value) db.ResetBox = value end
                    },

                }
            },
       
        }
    }
    return options
end



