--[[
###################################
Ultra XP,Rep,Azerite Bars: keivamp#
###################################
]]--

	local UltraXPRA_Bars = LibStub("AceAddon-3.0"):GetAddon("UltraXPRA_Bars")

	if (UnitLevel("player") <= 110) then return end
	local MyAzeriteXPWidth = 350
	local MyAzeriteXPHeight = 15
	local AzeX = -230
	local AzeY = -35
	local AzeriteFrame = CreateFrame("Frame", nil, UIParent)
	local MyAzeriteSettingsFrame = CreateFrame("Frame")

	local function CreateBackdrop(frame)
		frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
		insets = {top = 0, left = 0, bottom = 0, right = 0}})
		frame:SetBackdropColor(0,0,0,0.75)
		frame:SetBackdropBorderColor(0,0,0,1)
	end

	
	AzeriteFrame:EnableMouse(true)

	AzeriteFrame.bar = CreateFrame("StatusBar", nil, AzeriteFrame)
	AzeriteFrame.bar:SetPoint("TOPLEFT", 0, 0)
	AzeriteFrame.bar:SetPoint("TOPRIGHT", 0, 0)
	
	local AzeXPText = AzeriteFrame.bar:CreateFontString(nil, "OVERLAY", "SystemFont_Med1")
	AzeXPText:SetPoint("LEFT", 2, 0)	
	--AzeXPText:SetJustifyH("RIGHT")
			
	local AzeXPMaxText = AzeriteFrame.bar:CreateFontString(nil, "OVERLAY", "SystemFont_Med1")
	AzeXPMaxText:SetPoint("RIGHT", -2, 0)
	--AzeXPMaxText:SetJustifyH("LEFT")
			
	local AzeText = AzeriteFrame.bar:CreateFontString(nil, "OVERLAY", "SystemFont_Med1")
	AzeText:SetPoint("CENTER", 0, 0)
	--AzeText:SetJustifyH("CENTER")


local function AzeMe()
	if UltraXPRA_Bars.db.char.UseUltraAze == false then return end

		AzeX = UltraXPRA_Bars.db.char.AzeMoveX
		AzeY =  UltraXPRA_Bars.db.char.AzeMoveY
		MyAzeriteXPWidth = UltraXPRA_Bars.db.char.AzeWidth
		MyAzeriteXPHeight = UltraXPRA_Bars.db.char.AzeHeight
	
	
	--Fonts--
	local TheFont = ""
	if UltraXPRA_Bars.db.char.AzeFontKey == "2002" then
	TheFont = "Fonts\\2002.ttf"
	elseif UltraXPRA_Bars.db.char.AzeFontKey == "2002 Bold" then
	TheFont = "Fonts\\2002B.ttf"
	elseif UltraXPRA_Bars.db.char.AzeFontKey == "AR CrystalzcuheiGBK Demibold" then
	TheFont = "Fonts\\ARHei.ttf"
	elseif UltraXPRA_Bars.db.char.AzeFontKey == "AR ZhongkaiGBK Medium (Combat)" then
	TheFont = "Fonts\\ARKai_C.ttf"
	elseif UltraXPRA_Bars.db.char.AzeFontKey == "AR ZhongkaiGBK Medium" then
	TheFont = "Fonts\\ARKai_T.ttf"
	elseif UltraXPRA_Bars.db.char.AzeFontKey == "Arial Narrow" then
	TheFont = "Fonts\\ARIALN.ttf"
	elseif UltraXPRA_Bars.db.char.AzeFontKey == "Friz Quadrata TT" then
	TheFont = "Fonts\\FRIZQT__.ttf"
	elseif UltraXPRA_Bars.db.char.AzeFontKey == "MoK" then
	TheFont = "Fonts\\K_Pagetext.ttf"
	elseif UltraXPRA_Bars.db.char.AzeFontKey == "Morpheus" then
	TheFont = "Fonts\\MORPHEUS_CYR.ttf"
	elseif UltraXPRA_Bars.db.char.AzeFontKey == "Nimrod MT" then
	TheFont = "Fonts\\NIM_____.ttf"
	elseif UltraXPRA_Bars.db.char.AzeFontKey == "Skurri" then
	TheFont = "Fonts\\SKURRI_CYR.ttf"
	else
	TheFont = "Interface\\Addons\\UltraXPRA_Bars\\Fonts\\"..UltraXPRA_Bars.db.char.AzeFontKey..".ttf"
	end
	local TheFontOutline = "NONE"
	if UltraXPRA_Bars.db.char.AzeFontOutline == 1 then
	TheFontOutline = "NONE"
	elseif UltraXPRA_Bars.db.char.AzeFontOutline == 2 then
	TheFontOutline = "MONOCHROMEOUTLINE"
	elseif UltraXPRA_Bars.db.char.AzeFontOutline == 3 then
	TheFontOutline = "THINOUTLINE"
	elseif UltraXPRA_Bars.db.char.AzeFontOutline == 4 then
	TheFontOutline = "THICKOUTLINE"
	end
		if UltraXPRA_Bars.db.char.AzeFontKey == "Folkard" then
			AzeXPText:SetPoint("LEFT", 2, -3)
			AzeXPMaxText:SetPoint("RIGHT", -2, -3)
			AzeText:SetPoint("CENTER", 0, -3)
		elseif UltraXPRA_Bars.db.char.AzeFontKey == "Atari" then
			AzeXPText:SetPoint("LEFT", 2, 2)
			AzeXPMaxText:SetPoint("RIGHT", -2, 2)
			AzeText:SetPoint("CENTER", 0, 2)
		else
			AzeXPText:SetPoint("LEFT", 2, 0)
			AzeXPMaxText:SetPoint("RIGHT", -2, 0)
			AzeText:SetPoint("CENTER", 0, 0)
		end
	--end fonts --
		-- AzeX = UltraXPRA_Bars.db.char.AzeMoveX
		-- AzeY =  UltraXPRA_Bars.db.char.AzeMoveY
		-- MyAzeriteXPWidth = UltraXPRA_Bars.db.char.AzeWidth
		-- MyAzeriteXPHeight = UltraXPRA_Bars.db.char.AzeHeight
	
	
	
	--AzeX = UltraXPRA_Bars.db.char.AzeMoveX
	--AzeY =  UltraXPRA_Bars.db.char.AzeMoveY
	
	AzeriteFrame:SetHeight(MyAzeriteXPHeight)
	AzeriteFrame:SetWidth(MyAzeriteXPWidth)

	AzeriteFrame:ClearAllPoints()
	AzeriteFrame:SetPoint("TOP", UIParent, "TOP", AzeX,AzeY)

	AzeriteFrame:SetClampedToScreen(true)
	AzeriteFrame:SetClampRectInsets(0, 0, 0,0)
		
	AzeriteFrame:CreateBeautyBorder(4)
	AzeriteFrame:SetBeautyBorderPadding(1)
	AzeriteFrame:SetBeautyBorderTexture("white")
	
	CreateBackdrop(AzeriteFrame)
	if UltraXPRA_Bars.db.char.UseVertAze == true then
		AzeriteFrame.bar:SetOrientation("VERTICAL")
		UltraXPRA_Bars.db.char.AzeritePower = false
		UltraXPRA_Bars.db.char.ShowMaxAze = false
		UltraXPRA_Bars.db.char.ShowMinAze = false
	else
		AzeriteFrame.bar:SetOrientation("HORIZONTAL")
	end

	AzeriteFrame.bar:SetHeight(MyAzeriteXPHeight)
	AzeriteFrame.bar:SetStatusBarTexture("Interface\\TargetingFrame\\UI-StatusBar")
	AzeriteFrame.bar:GetStatusBarTexture():SetHorizTile(false)
	AzeriteFrame.bar:GetStatusBarTexture():SetVertTile(false)
	AzeriteFrame.bar:SetStatusBarColor(0.9, 0.64, 0.37)
	AzeriteFrame:SetBeautyBorderColor(0.9, 0.64, 0.37,0.75)

	if UltraXPRA_Bars.db.char.AzeCustomFont == false then 
	AzeText:SetFont("SystemFont_Med1", MyAzeriteXPHeight-4, "OUTLINE")
	AzeText:SetTextColor(1, 1, 1, 1);
	AzeXPMaxText:SetFont("SystemFont_Med1", MyAzeriteXPHeight-4, "OUTLINE")
	AzeXPMaxText:SetTextColor(1, 1, 1, 1);
	AzeXPText:SetFont("SystemFont_Med1", MyAzeriteXPHeight-4, "OUTLINE")	
	AzeXPText:SetTextColor(1, 1, 1, 1);
	else
	AzeText:SetFont(TheFont, UltraXPRA_Bars.db.char.AzeFontSize, TheFontOutline)
	AzeXPMaxText:SetFont(TheFont, UltraXPRA_Bars.db.char.AzeFontSize, TheFontOutline)
	AzeXPText:SetFont(TheFont, UltraXPRA_Bars.db.char.AzeFontSize, TheFontOutline)	
	end	

end	
MyAzeriteSettingsFrame:HookScript("OnUpdate",AzeMe) 

local function UltraAzerite(self, event, ...)

			local isHeartOfAzerothEquipped = C_AzeriteEmpoweredItem.IsHeartOfAzerothEquipped()			
						
				if isHeartOfAzerothEquipped == true then	
					local azeriteItemLocation = C_AzeriteItem.FindActiveAzeriteItem(); 
					local xp, totalLevelXP = C_AzeriteItem.GetAzeriteItemXPInfo(azeriteItemLocation);
					local currentLevel = C_AzeriteItem.GetPowerLevel(azeriteItemLocation); 
					local xpToNextLevel = totalLevelXP - xp; 						
					AzeriteFrame:Show(); 						
					AzeriteFrame.bar:SetMinMaxValues(0, totalLevelXP)
					AzeriteFrame.bar:SetValue(xp)
					
					if UltraXPRA_Bars.db.char.ShowMinAze == true then 
					AzeXPText:SetText(xp)
					else
					AzeXPText:SetText("")
					end
					if UltraXPRA_Bars.db.char.ShowMaxAze == true then 
					AzeXPMaxText:SetText(totalLevelXP)	
					else
					AzeXPMaxText:SetText("")
					end	
					if UltraXPRA_Bars.db.char.AzeritePower == true then 
					AzeText:SetText("Azerite: "..currentLevel) 
					else
					AzeText:SetText("")
					end

				end	
				if isHeartOfAzerothEquipped == false then
						return
				end	
						
		
		end
		local UltraAzeriteEvent = CreateFrame("FRAME")
		UltraAzeriteEvent:SetScript("OnUpdate", UltraAzerite)

	local function OnEvent(self)
			
		self:SetScript("OnEnter", function()
			
				local rested = GetXPExhaustion()
			
			GameTooltip:SetOwner(self, "ANCHOR_BOTTOM", 0, -10)
			GameTooltip:ClearAllPoints()
			GameTooltip:SetPoint("BOTTOM", self, "TOP", 0, 1)
			GameTooltip:ClearLines()
			local azeriteItemLocation = C_AzeriteItem.FindActiveAzeriteItem(); 
					local xp, totalLevelXP = C_AzeriteItem.GetAzeriteItemXPInfo(azeriteItemLocation);
					local currentLevel = C_AzeriteItem.GetPowerLevel(azeriteItemLocation); 
					local xpToNextLevel = totalLevelXP - xp; 
			--GameTooltip:AddLine(" ")
			GameTooltip:AddDoubleLine("Heart of Azeroth")
			GameTooltip:AddLine(" ")
			GameTooltip:AddDoubleLine(xp.." / "..totalLevelXP)
		
			GameTooltip:Show()
	
		end)
		
		self:SetScript("OnLeave", function() GameTooltip:Hide() end)
		end
		AzeriteFrame:SetScript("OnMouseDown", function(self, button)
		if button == "RightButton" then
			
			self:GetScript("OnEnter")(self)
		else
			ToggleCharacter("PaperDollFrame")
		end
	end)

	AzeriteFrame:SetScript("OnEvent", OnEvent)
	AzeriteFrame:HookScript("OnUpdate", OnEvent)