--[[
###################################
Ultra XP,Rep,Azerite Bars: keivamp#
###################################
]]--
local UltraXPRA_Bars = LibStub("AceAddon-3.0"):NewAddon("UltraXPRA_Bars", "AceEvent-3.0", "LibAboutPanel-2.0", "AceConsole-3.0")
--local L = LibStub("AceLocale-3.0"):GetLocale("UltraXPRA_Bars")
local Dialog = LibStub("AceConfigDialog-3.0")

local db
local defaults = {
    char = {
        enabled = false,
		UseUltraXP = true,
		XPMoveY = -10,
		XPMoveX = -230,
		XPWidth = 350,
		XPHeight = 15,
		ShowRested = true,
		ShowMaxXP = true,
		ShowMinXP = true,
		XPCustomFont = true,
		UseUltraRep = true,
		RepMoveY = -10,
		RepMoveX = 230,
		RepWidth = 350,
		RepHeight = 15,
		ShowFactionName = true,
		ShowMaxRep = true,
		ShowMinRep = true,
		RepCustomFont = true,
		UseUltraAze = true,
		AzeMoveY = -35,
		AzeMoveX = -230,
		AzeWidth = 350,
		AzeHeight = 15,
		AzeritePower = true,
		ShowMaxAze = true,
		ShowMinAze = true,
		AzeCustomFont = true,
		ResetBox = false,
		FontKey = "ThisFont",
		FontOutline = 1,
		FontSize = 12,
		XPFontKey = "ThisFont",
		XPFontOutline = 1,
		XPFontSize = 12,
		RepFontKey = "ThisFont",
		RepFontOutline = 1,
		RepFontSize = 12,
		AzeFontKey = "ThisFont",
		AzeFontOutline = 1,
		AzeFontSize = 12,
		UseVertXP = false,
		UseVertRep = false,
		UseVertAze = false
    }
}



function UltraXPRA_Bars:OnInitialize()
    self.db = LibStub("AceDB-3.0"):New("UltraChar", defaults,true,true)
    -- self.db.RegisterCallback(self, "OnProfileChanged", "RefreshConfig")
    -- self.db.RegisterCallback(self, "OnProfileCopied", "ProfileCopied")
    -- self.db.RegisterCallback(self, "OnProfileReset", "RefreshConfig")
    self:SetEnabledState(self.db.char.enabled)
    db = self.db.char

   local Options = self:GetOptions() -- Options.lua

   --Options.args.profiles = LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db)
   

   Options.args.aboutTab = self:AboutOptionsTable("UltraXPRA_Bars")
   Options.args.aboutTab.order = -1 -- -1 means "put it last"

   LibStub("AceConfig-3.0"):RegisterOptionsTable("UltraXPRA_Bars", Options)


    self.optionsFrame = Dialog:AddToBlizOptions("UltraXPRA_Bars", "UltraXPRA_Bars")
	--activeProfile = db:GetCurrentProfile()
	


end

function UltraXPRA_Bars:OnEnable()
	UltraXPRA_Bars.db = defaults
	--db = self.db.char
	--UltraXPRA_Bars.db.char.profile = self.db.char
	--activeProfile = db:GetCurrentProfile()
-- MyMonkey()
-- MyMonkey2()
end

function UltraXPRA_Bars:OnDisable()

	db = self.db.char
	
	--db.UseUltraAze == false
	
	--UltraXPRA_Bars.db.char.profile = self.db.char
	--print(db)
end

function MyMonkey()

end
function MyMonkey2()

end
function UltraXPRA_Bars:RefreshConfig()
	--db = self.db.char
	--UltraXPRA_Bars.db.char.profile = self.db.char
end



		SLASH_UltraXPRA_Bars1 = "/UBarcfg"
		SLASH_UltraXPRA_Bars2 = "/UBC"
		SLASH_UltraXPRA_Bars3 = "/urbc"
		_G.SlashCmdList.RELOADUI = ReloadUI
		SLASH_RELOADUI1 = "/rl"
		SLASH_RELOADUI2 = "/reload"
		SLASH_RELOADUI3 = "/reloadui"
	SlashCmdList["UltraXPRA_Bars"] = function() 
    InterfaceOptionsFrame_OpenToCategory("UltraXPRA_Bars")
	InterfaceOptionsFrame_OpenToCategory("UltraXPRA_Bars")
	InterfaceOptionsFrame_OpenToCategory("UltraXPRA_Bars")
	end